package userdb;

//
// Interface definition : UnixUserHome
//
// @author OpenORB Compiler
//
public class UnixUserHomePOATie extends UnixUserHomePOA
{

	//
	// Private reference to implementation object
	//
	private UnixUserHomeOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public UnixUserHomePOATie( UnixUserHomeOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public UnixUserHomePOATie( UnixUserHomeOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public UnixUserHomeOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( UnixUserHomeOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Operation find_by_login
	//
	public userdb.UnixUser find_by_login(String login)
		throws userdb.UnixUserNotFound
	{
		return _tie.find_by_login( login);
	}

}
