package userdb;

//
// Interface definition : UnixUser
//
// @author OpenORB Compiler
//
public class UnixUserPOATie extends UnixUserPOA
{

	//
	// Private reference to implementation object
	//
	private UnixUserOperations _tie;

	//
	// Private reference to POA
	//
	private org.omg.PortableServer.POA _poa;

	//
	// Constructor
	//
	public UnixUserPOATie( UnixUserOperations tieObject )
	{
		_tie = tieObject;
	}

	//
	// Constructor
	//
	public UnixUserPOATie( UnixUserOperations tieObject, org.omg.PortableServer.POA poa )
	{
		_tie = tieObject;
		_poa = poa;
	}

	//
	// Get the delegate
	//
	public UnixUserOperations _delegate()
	{
		return _tie;
	}

	//
	// Set the delegate
	//
	public void _delegate( UnixUserOperations delegate_)
	{
		_tie = delegate_;
	}

	//
	//
	//
	public org.omg.PortableServer.POA _default_POA()
	{
		if ( _poa != null )
		    return _poa;
		else
		    return super._default_POA();
	}

	//
	// Read accessor for sid attribute
	//
	public String sid()
	{
		return _tie.sid();
	}

	//
	// Read accessor for login attribute
	//
	public String login()
	{
		return _tie.login();
	}

	//
	// Read accessor for uid attribute
	//
	public int uid()
	{
		return _tie.uid();
	}

	//
	// Read accessor for gid attribute
	//
	public int gid()
	{
		return _tie.gid();
	}

	//
	// Read accessor for name attribute
	//
	public String name()
	{
		return _tie.name();
	}

	//
	// Read accessor for homedir attribute
	//
	public String homedir()
	{
		return _tie.homedir();
	}

	//
	// Read accessor for status attribute
	//
	public userdb.UnixUserStatus status()
	{
		return _tie.status();
	}

	//
	// Write accessor for status attribute
	//
	public void status( userdb.UnixUserStatus value )
	{
		_tie.status(value);
	}

}
