package userdb;

//
// Interface definition : UnixUserHome
//
// @author OpenORB Compiler
//
public class _UnixUserHomeStub extends org.omg.CORBA.portable.ObjectImpl
		implements UnixUserHome
{
	static final String[] _ids_list =
	{
		"IDL:userdb/UnixUserHome:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = userdb.UnixUserHomeOperations.class;

	//
	// Operation find_by_login
	//
	public userdb.UnixUser find_by_login(String login)
		throws userdb.UnixUserNotFound
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("find_by_login",true);
					_output.write_string(login);
					_input = this._invoke(_output);
					userdb.UnixUser _arg_ret = userdb.UnixUserHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(userdb.UnixUserNotFoundHelper.id()) )
					{
						throw userdb.UnixUserNotFoundHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("find_by_login",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserHomeOperations _self = ( userdb.UnixUserHomeOperations ) _so.servant;
				try
				{
					return _self.find_by_login( login);
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation get_user_list
	//
	public userdb.ShortInfo[] get_user_list()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("get_user_list",true);
					_input = this._invoke(_output);
					userdb.ShortInfo[] _arg_ret = userdb.ShortInfoListHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_user_list",_opsClass);
				if ( _so == null )
				   continue;
				userdb.UnixUserHomeOperations _self = ( userdb.UnixUserHomeOperations ) _so.servant;
				try
				{
					return _self.get_user_list();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
