package userdb;

//
// Interface definition : UnixUserResource
//
// @author OpenORB Compiler
//
public class _UnixUserResourceStub extends org.omg.CORBA.portable.ObjectImpl
		implements UnixUserResource
{
	static final String[] _ids_list =
	{
		"IDL:userdb/UnixUserResource:1.0", 
		"IDL:omg.org/CosTransactions/Resource:1.0"
	};

	public String[] _ids()
	{
		return _ids_list;
	}

	private final static Class _opsClass = userdb.UnixUserResourceOperations.class;

	//
	// Operation prepare
	//
	public org.omg.CosTransactions.Vote prepare()
		throws org.omg.CosTransactions.HeuristicMixed, org.omg.CosTransactions.HeuristicHazard
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("prepare",true);
					_input = this._invoke(_output);
					org.omg.CosTransactions.Vote _arg_ret = org.omg.CosTransactions.VoteHelper.read(_input);
					return _arg_ret;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicMixedHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicMixedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicHazardHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicHazardHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("prepare",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CosTransactions.ResourceOperations _self = ( org.omg.CosTransactions.ResourceOperations ) _so.servant;
				try
				{
					return _self.prepare();
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation rollback
	//
	public void rollback()
		throws org.omg.CosTransactions.HeuristicCommit, org.omg.CosTransactions.HeuristicMixed, org.omg.CosTransactions.HeuristicHazard
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("rollback",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicCommitHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicCommitHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicMixedHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicMixedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicHazardHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicHazardHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("rollback",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CosTransactions.ResourceOperations _self = ( org.omg.CosTransactions.ResourceOperations ) _so.servant;
				try
				{
					_self.rollback();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation commit
	//
	public void commit()
		throws org.omg.CosTransactions.NotPrepared, org.omg.CosTransactions.HeuristicRollback, org.omg.CosTransactions.HeuristicMixed, org.omg.CosTransactions.HeuristicHazard
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("commit",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.CosTransactions.NotPreparedHelper.id()) )
					{
						throw org.omg.CosTransactions.NotPreparedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicRollbackHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicRollbackHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicMixedHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicMixedHelper.read(_exception.getInputStream());
					}

					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicHazardHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicHazardHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("commit",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CosTransactions.ResourceOperations _self = ( org.omg.CosTransactions.ResourceOperations ) _so.servant;
				try
				{
					_self.commit();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation commit_one_phase
	//
	public void commit_one_phase()
		throws org.omg.CosTransactions.HeuristicHazard
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("commit_one_phase",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					if ( _exception_id.equals(org.omg.CosTransactions.HeuristicHazardHelper.id()) )
					{
						throw org.omg.CosTransactions.HeuristicHazardHelper.read(_exception.getInputStream());
					}

					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("commit_one_phase",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CosTransactions.ResourceOperations _self = ( org.omg.CosTransactions.ResourceOperations ) _so.servant;
				try
				{
					_self.commit_one_phase();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

	//
	// Operation forget
	//
	public void forget()
	{
		while( true )
		{
			if (!this._is_local() )
			{
				org.omg.CORBA.portable.InputStream _input = null;
				try
				{
					org.omg.CORBA.portable.OutputStream _output = this._request("forget",true);
					_input = this._invoke(_output);
					return;
				}
				catch( org.omg.CORBA.portable.RemarshalException _exception )
				{
					continue;
				}
				catch( org.omg.CORBA.portable.ApplicationException _exception )
				{
					String _exception_id = _exception.getId();
					throw new org.omg.CORBA.UNKNOWN("Unexcepected User Exception: "+ _exception_id);
				}
				finally
				{
					this._releaseReply(_input);
				}
			}
			else
			{
				org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("forget",_opsClass);
				if ( _so == null )
				   continue;
				org.omg.CosTransactions.ResourceOperations _self = ( org.omg.CosTransactions.ResourceOperations ) _so.servant;
				try
				{
					_self.forget();
					return;
				}
				finally
				{
					_servant_postinvoke(_so);
				}
			}
		}
	}

}
