
import userdb.*;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.CosNaming.*;


class HomeDirCreatorServer
{
	
    public static void main (String argv[])
    {
        try
        {
            Class.forName("org.postgresql.Driver");
            String dbUrl = "jdbc:postgresql:userdb";
            String dbUser = "useradmin";
            String dbPassword = "";

            ORB orb = ORB.init(argv, null);

            POA rootPOA = POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));


            NamingContextExt ctx = NamingContextExtHelper.narrow(
                orb.resolve_initial_references("NameService"));


            HomeDirCreatorPOA hdc = new HomeDirCreatorImpl3 (orb, rootPOA);

            org.omg.CORBA.Object obj = rootPOA.servant_to_reference(hdc);

            ctx.rebind( ctx.to_name("HomeDirCreator"), obj);

            rootPOA.the_POAManager().activate();

            System.out.println("HomeDirCreatorServer is ready.");

            orb.run();


	}
	catch (Exception e)
	{
	    e.printStackTrace();
	}
    }
}
