package userdb;

//
// Interface definition : HomeDirCreator
//
// @author OpenORB Compiler
//
public abstract class HomeDirCreatorPOA extends org.omg.PortableServer.Servant
		implements HomeDirCreatorOperations, org.omg.CORBA.portable.InvokeHandler
{
	public HomeDirCreator _this()
	{
		return HomeDirCreatorHelper.narrow(_this_object());
	}

	public HomeDirCreator _this( org.omg.CORBA.ORB orb )
	{
		return HomeDirCreatorHelper.narrow(_this_object(orb));
	}

	private static String [] _ids_list =
	{
		"IDL:userdb/HomeDirCreator:1.0", 
		"IDL:omg.org/CosTransactions/TransactionalObject:1.0"
	};

	public String[] _all_interfaces( org.omg.PortableServer.POA poa, byte [] objectId)
	{
		return _ids_list;
	}

	public org.omg.CORBA.portable.OutputStream _invoke ( String opName,
	                                                     org.omg.CORBA.portable.InputStream _is,
	                                                     org.omg.CORBA.portable.ResponseHandler handler)
	{
		org.omg.CORBA.portable.OutputStream _output = null;

		if ( opName.equals("makeHomeDir") )
		{
			String arg0_in = _is.read_string();
			int arg1_in = _is.read_long();
			int arg2_in = _is.read_long();

			makeHomeDir(arg0_in, arg1_in, arg2_in);

			_output = handler.createReply();

			return _output;
		}
		else
			throw new org.omg.CORBA.BAD_OPERATION();
	}
}
