package userdb;

//
// Helper class for : HomeDirCreator
//
// @author OpenORB Compiler
//
public class HomeDirCreatorHelper
{
	//
	// Insert HomeDirCreator into an any
	// @param	a an any
	// @param	t HomeDirCreator value
	//
	public static void insert( org.omg.CORBA.Any a, userdb.HomeDirCreator t )
	{
		a.insert_Object( t , type() );
	}

	//
	// Extract HomeDirCreator from an any
	// @param	a an any
	// @return the extracted HomeDirCreator value
	//
	public static userdb.HomeDirCreator extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		try {
			return userdb.HomeDirCreatorHelper.narrow( a.extract_Object() );
		}
		catch ( org.omg.CORBA.BAD_PARAM ex ) {
			throw new org.omg.CORBA.MARSHAL();
		}
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the HomeDirCreator TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			_tc = orb.create_interface_tc(id(),"HomeDirCreator");
		}
		return _tc;
	}

	//
	// Return the HomeDirCreator IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:userdb/HomeDirCreator:1.0";

	//
	// Read HomeDirCreator from a marshalled stream
	// @param	istream the input stream
	// @return the readed HomeDirCreator value
	//
	public static userdb.HomeDirCreator read( org.omg.CORBA.portable.InputStream istream )
	{
		return( userdb.HomeDirCreator )istream.read_Object( userdb._HomeDirCreatorStub.class );
	}

	//
	// Write HomeDirCreator into a marshalled stream
	// @param	ostream the output stream
	// @param	value HomeDirCreator value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, userdb.HomeDirCreator value )
	{
		ostream.write_Object((org.omg.CORBA.portable.ObjectImpl)value);
	}

	//
	// Narrow CORBA::Object to HomeDirCreator
	// @param	obj the CORBA Object
	// @return HomeDirCreator Object
	//
	public static HomeDirCreator narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof HomeDirCreator )
			return ( HomeDirCreator)obj;

		if ( obj._is_a( id() ) )
		{
			_HomeDirCreatorStub stub = new _HomeDirCreatorStub();
			stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
			return stub;
		}

		throw new org.omg.CORBA.BAD_PARAM();
	}

	//
	// Unchecked Narrow CORBA::Object to HomeDirCreator
	// @param	obj the CORBA Object
	// @return HomeDirCreator Object
	//
	public static HomeDirCreator unchecked_narrow( org.omg.CORBA.Object obj )
	{
		if ( obj == null )
			return null;
		if ( obj instanceof HomeDirCreator )
			return ( HomeDirCreator)obj;

		_HomeDirCreatorStub stub = new _HomeDirCreatorStub();
		stub._set_delegate( ((org.omg.CORBA.portable.ObjectImpl)obj)._get_delegate() );
		return stub;

	}

}
