package userdb;

//
// Helper class for : UnixUserStatus
//
// @author OpenORB Compiler
//
public class UnixUserStatusHelper
{
	//
	// Insert UnixUserStatus into an any
	// @param	a an any
	// @param	t UnixUserStatus value
	//
	public static void insert( org.omg.CORBA.Any a, userdb.UnixUserStatus t )
	{
		a.type( type() );
		write(a.create_output_stream(),t);
	}

	//
	// Extract UnixUserStatus from an any
	// @param	a an any
	// @return the extracted UnixUserStatus value
	//
	public static userdb.UnixUserStatus extract( org.omg.CORBA.Any a )
	{
		if ( !a.type().equal( type() ) )
			throw new org.omg.CORBA.MARSHAL();
		return read(a.create_input_stream());
	}

	//
	// Internal TypeCode value
	//
	private static org.omg.CORBA.TypeCode _tc = null;

	//
	// Return the UnixUserStatus TypeCode
	// @return a TypeCode
	//
	public static org.omg.CORBA.TypeCode type()
	{
		if ( _tc == null ) {
			org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
			String []_members = new String[4];
			_members[0] = "NEW";
			_members[1] = "READY";
			_members[2] = "DENY_ACCESS";
			_members[3] = "DELETED";
			_tc = orb.create_enum_tc(id(),"UnixUserStatus",_members);
		}
		return _tc;
	}

	//
	// Return the UnixUserStatus IDL ID
	// @return an ID
	//
	public static String id()
	{
		return _id;
	}

	private final static String _id = "IDL:userdb/UnixUserStatus:1.0";

	//
	// Read UnixUserStatus from a marshalled stream
	// @param	istream the input stream
	// @return the readed UnixUserStatus value
	//
	public static userdb.UnixUserStatus read( org.omg.CORBA.portable.InputStream istream )
	{
		return UnixUserStatus.from_int(istream.read_ulong());
	}

	//
	// Write UnixUserStatus into a marshalled stream
	// @param	ostream the output stream
	// @param	value UnixUserStatus value
	//
	public static void write( org.omg.CORBA.portable.OutputStream ostream, userdb.UnixUserStatus value )
	{
		ostream.write_ulong(value.value());
	}

}
